{
 How to drag text from TStringGrid to TSRichViewEdit

 This demo uses system (OLE) drag & drop.
 Drag source is implemented using TDropTextSource component:
 https://github.com/DelphiPraxis/The-Drag-and-Drop-Component-Suite-for-Delphi
 The editor processes system d&d automatically.
}

unit MainFrm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics,
  Controls, Forms, Dialogs, Grids,
  RVScroll, RichView, RVEdit, CRVFData, SclRView, DragDrop, DropSource,
  DragDropText;

type
  TfrmMain = class(TForm)
    StringGrid1: TStringGrid;
    SRichViewEdit1: TSRichViewEdit;
    DropTextSource1: TDropTextSource;
    procedure FormCreate(Sender: TObject);
    procedure StringGrid1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    { Private declarations }
  public
    { Public declarations }

  end;

var
  frmMain: TfrmMain;

implementation

{$R *.dfm}

procedure TfrmMain.FormCreate(Sender: TObject);
begin
  StringGrid1.Cells[0,0] := 'AA';
  StringGrid1.Cells[1,0] := 'AB';
  StringGrid1.Cells[2,0] := 'AC';
  StringGrid1.Cells[0,1] := 'BA';
  StringGrid1.Cells[1,1] := 'BB';
  StringGrid1.Cells[2,1] := 'BC';
end;


procedure TfrmMain.StringGrid1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
  Col, Row: Integer;
begin
  if Button <> mbLeft then
    exit;
  StringGrid1.MouseToCell(X, Y, Col, Row);
  if (Row < 0) or (Col < 0) then
    exit;
  if DragDetectPlus(TWinControl(Sender)) then
  begin
    DropTextSource1.Text := StringGrid1.Cells[Col, Row];
    DropTextSource1.Execute;
  end;
end;





end.

